/********************************************************************/
/* Copyright (c) 2019 System fugen G.K. and Yuzi Mizuno          */
/* All rights reserved.                                             */
/********************************************************************/
/********************************************************************/
/**
 * @file RectCenter.h
 * @brief MGRectCenterTool クラスのインターフェイス
 */
#if !defined(AFX_RECTCENTER_H__91AAF8F0_A6B9_4A02_953A_CCDB0D71BDEC__INCLUDED_)
#define AFX_RECTCENTER_H__91AAF8F0_A6B9_4A02_953A_CCDB0D71BDEC__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Common/LocateState.h"
#include "Calc/rect.h"

class MGCommandStateOwner;

/// @class MGRectCenterTool RectCenter.h "CurveCmd/RectCenter.h"
///
/// 最初に中心を指定してから矩形の形状を決める。
class MGRectCenterTool : public MGLocateState{
public:
	explicit MGRectCenterTool(MGCommandStateOwner* owner);
	explicit MGRectCenterTool(fugenDoc* pDoc);
	virtual MGCommandBase* initial_clone(fugenDoc* pDoc)const;
	virtual bool initiate_tool();
	virtual bool terminate_tool(bool cancel = false);
	virtual bool OnKeyDown(fugenView* pView, UINT nChar, UINT nRepCnt, UINT nFlags);
	virtual bool OnLocated(const MGLocateInfo& info);
	virtual void do_make_temporary_display(mgSysGL& sgl,fugenView* pSView);
	
private:
	bool calculate(const MGPosition& posLast);
	void prompt_message() const;

	mgcalc::MGRect m_rect; ///< 一時描画用
	mgcalc::MGRoundRect m_round_rect; ///< 一時描画用
	double m_dRadius; ///< ラウンドコーナーの半径
	bool m_bRound; ///< 長方形の角を丸くするか
};

#endif // !defined(AFX_RECTCENTER_H__91AAF8F0_A6B9_4A02_953A_CCDB0D71BDEC__INCLUDED_)
